# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: reward.proto
# plugin: python-betterproto
from dataclasses import dataclass
from typing import List, Optional

import betterproto
import grpclib


@dataclass(eq=False, repr=False)
class Reward(betterproto.Message):
    id: int = betterproto.int32_field(1)
    activity: "_monster__.Activity" = betterproto.message_field(2)
    item_list: "_item__.ItemIdList" = betterproto.message_field(3)
    owner: "_common__.UserId" = betterproto.message_field(4)
    collected: bool = betterproto.bool_field(5)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class RewardList(betterproto.Message):
    reward: List["Reward"] = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


class RewardServiceStub(betterproto.ServiceStub):
    async def create_reward(
        self,
        *,
        id: int = 0,
        teams: Optional[List["Team"]] = None,
        state: "BattleState" = None,
        last_update: datetime = None,
        is_test: bool = False,
    ) -> "Reward":
        teams = teams or []

        request = _battle__.Battle()
        request.id = id
        if teams is not None:
            request.teams = teams
        if state is not None:
            request.state = state
        if last_update is not None:
            request.last_update = last_update
        request.is_test = is_test

        return await self._unary_unary(
            "/reward.RewardService/CreateReward", request, Reward
        )

    async def get_reward(self, *, id: int = 0) -> "Reward":

        request = _common__.RewardId()
        request.id = id

        return await self._unary_unary(
            "/reward.RewardService/getReward", request, Reward
        )

    async def collect_reward(self, *, id: int = 0) -> "_common__.ResponseStatus":

        request = _common__.RewardId()
        request.id = id

        return await self._unary_unary(
            "/reward.RewardService/collectReward", request, _common__.ResponseStatus
        )

    async def get_all_rewards_by_user(self, *, id: int = 0) -> "RewardList":

        request = _common__.UserId()
        request.id = id

        return await self._unary_unary(
            "/reward.RewardService/getAllRewardsByUser", request, RewardList
        )


from .. import battle as _battle__
from .. import common as _common__
from .. import item as _item__
from .. import monster as _monster__
